%       
%  f(x)=lambda*exp(-lambda*x), x>0

%     
close all
%    (WORKSPACE)
clear

%  INLINE- fline, ..  , 
%      
%  f(x)=P1*exp(-P1*x), x>0; P1=lambda -  -.
%  "-"       , 
%        FMIN

fline=inline('-(1/((2^(P1/2))*gamma(P1)))*(x^((P1/2)-1))*exp(-x/2)',1)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                                            %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% P1 -  
P1=4;
%%P2=1;
% N -   ,   
%%N=500;
% xi -        [0,1] 
%%xi=rand(N,1);
% eta -       
%       -   
%    F(x)=1-exp(-lambda*x), x>0
%%eta=-1/P1*log(xi);

%       
%    eta,      
% .
% M -        
% ,        
%   .
%%M=40;
% f_est1 -   
% x -  ,      
%   .
%  .
%%[f_est1,x]=hist(eta,M);
%   .
%%f_est1=f_est1/(N*(x(2)-x(1)));

%       x.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                                                    %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% a -      
a=0;
%% b -      
b=10;
%  ,     
%     . 
%   FMIN.
Xmax=fminbnd(fline,a,b,[],P1);
% Fmax -      
Fmaxbnd=-feval(fline,Xmax,P1);
% n -       
n=1;
% nn -       
nn=1;
% ,    
while n<=N
   xi1=a+(b-a)*rand(1,1);% xi1 - 1-  
   xi2=Fmaxbnd*rand(1,1);   % xi2 - 2-  
   if xi2<=-feval(fline,xi1,P1) %   xi2 <= f(xi1)
      eta(n)=xi1; %  
      n=n+1;      %    
   end;
   nn=nn+1;       %    
end;
%    nn  n
[nn n]

%   
% f_est2 -   
f_est2=hist(eta,x);
f_est2=f_est2/(N*(x(2)-x(1)));
   
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                                                   %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% K -         
% ,       .
%%K=100;
% p -          
%%p=1/K;
% X -  ,   
%%X(1)=a;
%      X
%%for k=2:K+1
   %%X(k)=-1/P1*log(exp(-P1*X(k-1))-p);
   %%end;
%        
%%for n=1:N
  %% xi1=rand(1,1);% xi1 - 1-  
   %%k=round((K-1)*xi1)+1;% k -    
   %%xi2=rand(1,1);% xi2 - 2-  
   %%eta(n)=X(k)+xi2*(X(k+1)-X(k));%    
   %%end;

%   
% f_est3 -   
%%f_est3=hist(eta,x);
%%f_est3=f_est3/(N*(x(2)-x(1)));
   
   %  :
   % f      -   ,  
   % f_est1 -    ,    ,
   %           
   % f_est2 -    ,   ,
   %           
   % f_est3 -    ,   ,
   %           
%       
figure(1)
%  
plot(x,f,x,f_est1,x,f_est2,x,f_est3)
%   
title(' ')
%   
xlabel('x')
%   
ylabel('f(x)')
%  
grid